%define	major 0
%define libname %mklibname xpdf %{major}
%define develname %mklibname xpdf -d

%define urwdir %{_datadir}/fonts/default/Type1
%define x11dir		/usr/X11R6

%define _disable_ld_no_undefined 1

Summary:	A PDF file viewer for the X Window System
Name:		xpdf
Version:	4.04
Release:	%mkrel 2
License:	GPLv2+
URL:		https://www.xpdfreader.com/
Group:		Publishing
Source:		https://dl.xpdfreader.com/%{name}-%{version}.tar.gz
Source1:	icons-%{name}.tar.bz2
Source3:	https://dl.xpdfreader.com/%{name}-chinese-simplified.tar.gz
Source4:	https://dl.xpdfreader.com/%{name}-chinese-traditional.tar.gz
Source5:	https://dl.xpdfreader.com/%{name}-japanese.tar.gz
Source6:	https://dl.xpdfreader.com/%{name}-korean.tar.gz
Source7:	https://dl.xpdfreader.com/%{name}-cyrillic.tar.gz
Source8:	https://dl.xpdfreader.com/%{name}-thai.tar.gz
Source12:	https://dl.xpdfreader.com/%{name}-arabic.tar.gz
Source13:	https://dl.xpdfreader.com/%{name}-greek.tar.gz
Source14:	https://dl.xpdfreader.com/%{name}-hebrew.tar.gz
Source15:	https://dl.xpdfreader.com/%{name}-latin2.tar.gz
Source16:	https://dl.xpdfreader.com/%{name}-turkish.tar.gz

Patch3:		%{name}-4.01-ext.patch
Patch11:	%{name}-4.01-crash.patch
Patch12:	%{name}-4.01-64bit.patch

# Security patches
Patch101:	xpdf-4.02-CVE-2019-12360.patch

# Debian patches
Patch200:	xpdf-4.02-permissions.patch
# Proper stream encoding on 64bit platforms
Patch203:	fix-444648.dpatch

Requires:	urw-fonts
Requires:	xdg-utils
Requires:	poppler
# Lesstif user interface requires these
Requires:	x11-font-adobe-75dpi
Requires:	x11-font-adobe-100dpi
Requires:	%{_lib}qt5svg5
Requires:	%{name}-common >= %{version}-%{release}

BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xt)
BuildRequires:	pkgconfig(xpm)
BuildRequires:	freetype2-devel >= 2.1.7
BuildRequires:	pkgconfig(zlib)
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(xrender)
BuildRequires:	pkgconfig(xft)
BuildRequires:	libpaper-devel
BuildRequires:	autoconf
BuildRequires:	libtool
BuildRequires:	pkgconfig(libpng)
BuildRequires:	qt5-devel
BuildRequires:	cmake
BuildRequires:	cups-devel

%description
Xpdf is an X Window System based viewer for Portable Document Format (PDF)
files. PDF files are sometimes called Acrobat files, after Adobe Acrobat
(Adobe's PDF viewer).  Xpdf is a small and efficient program which uses
standard X fonts.

%package	common
Group:		Publishing
Summary:	Common files for xpdf and the applications based on it
Conflicts:	xpdf < 3.02-7

%description	common
Xpdf is an X Window System based viewer for Portable Document Format (PDF)
files. PDF files are sometimes called Acrobat files, after Adobe Acrobat
(Adobe's PDF viewer).  Xpdf is a small and efficient program which uses
standard X fonts.

This package contains common files (such as UnicodeMap and xpdfrc) needed for
xpdf and the applications based on it.

%prep
%setup -q -a 3 -a 4 -a 5 -a 6 -a 7 -a 8 -a 12 -a 13 -a 14 -a 15 -a 16
%autopatch -p1

# Comment out unused urlCommand option
sed -i 's|urlCommand|#urlCommand|g' doc/sample-xpdfrc

%build
find -name "*orig" | xargs rm -f

# This may seem pointless, but in the unlikely event that _sysconfdir != /etc ...
for file in doc/*.1 doc/*.5 xpdf-*/README; do
  sed -i -e 's:/etc/xpdfrc:%{_sysconfdir}/xpdfrc:g' $file
done
# Same action for _datadir.
for file in xpdf-*/README xpdf-*/add-to-xpdfrc; do
  sed -i -e 's:/usr/share/:%{_datadir}/:g' $file
  sed -i -e 's:/usr/local/share/:%{_datadir}/:g' $file
done

export CFLAGS="%{optflags} -fPIC"
export CXXFLAGS="%{optflags} -Wno-deprecated -fPIC"
%cmake -DMULTITHREADED=ON -DOPI_SUPPORT=ON -DXPDFWIDGET_PRINTING=1 -DSYSTEM_XPDFRC="%{_sysconfdir}/xpdfrc"

%cmake_build

%install
for i in chinese-simplified chinese-traditional cyrillic japanese \
	korean thai greek latin2 turkish hebrew arabic; \
	do
		mkdir -p %{buildroot}%{_datadir}/%{name}/$i
		cp -a xpdf-$i/* %{buildroot}%{_datadir}/%{name}/$i/
	done

%cmake_install

mkdir -p %{buildroot}%{_libdir}
cp -a %{_vpath_builddir}/fofi/libfofi.so* %{buildroot}%{_libdir}
cp -a %{_vpath_builddir}/goo/libgoo.so* %{buildroot}%{_libdir}
cp -a %{_vpath_builddir}/splash/libsplash.so* %{buildroot}%{_libdir}

install -m 755 -d %{buildroot}%{_datadir}/applications/
cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Name=Xpdf
Comment=Views PDF files
Exec=%{_bindir}/%{name} %f
Icon=%{name}
Terminal=false
Type=Application
StartupNotify=true
MimeType=text/pdf;text/x-pdf;application/pdf;application/x-pdf;
Categories=Office;Viewer;
EOF

# mdk icons
install -d %{buildroot}%{_iconsdir}
tar xjf %{SOURCE1} -C %{buildroot}%{_iconsdir}

# poppler provides all utilities now
rm %{buildroot}%{_bindir}/pdfdetach
rm %{buildroot}%{_bindir}/pdffonts
rm %{buildroot}%{_bindir}/pdfimages
rm %{buildroot}%{_bindir}/pdfinfo
rm %{buildroot}%{_bindir}/pdftohtml
rm %{buildroot}%{_bindir}/pdftops
rm %{buildroot}%{_bindir}/pdftotext
rm %{buildroot}%{_bindir}/pdftoppm
rm %{buildroot}%{_mandir}/man1/pdftoppm.1*
rm %{buildroot}%{_mandir}/man1/pdfdetach.1*
rm %{buildroot}%{_mandir}/man1/pdffonts.1*
rm %{buildroot}%{_mandir}/man1/pdfimages.1*
rm %{buildroot}%{_mandir}/man1/pdfinfo.1*
rm %{buildroot}%{_mandir}/man1/pdftohtml.1*
rm %{buildroot}%{_mandir}/man1/pdftops.1*
rm %{buildroot}%{_mandir}/man1/pdftotext.1*

mkdir -p %{buildroot}%{_sysconfdir}/xpdf/
for i in arabic chinese-simplified chinese-traditional cyrillic greek hebrew japanese korean latin2 thai turkish; do
     mv %{buildroot}%{_datadir}/%{name}/$i/README README.$i
     mv %{buildroot}%{_datadir}/%{name}/$i/add-to-xpdfrc %{buildroot}%{_sysconfdir}/xpdf/add-to-xpdfrc.$i
done

# xpdfrc cleanup
mkdir -p %{buildroot}%{_sysconfdir}/
cp -a doc/sample-xpdfrc %{buildroot}%{_sysconfdir}/xpdfrc
sed -i -e 's:/usr/local/share/:%{_datadir}/:g' %{buildroot}%{_sysconfdir}/xpdfrc

%files
%license COPYING COPYING3
%doc CHANGES README README.*
%{_bindir}/xpdf
%{_bindir}/pdftopng
%{_libdir}/lib*.so
%{_mandir}/man1/pdftopng.1*
%{_mandir}/man1/xpdf.1*
%{_datadir}/applications/%{name}.desktop
%{_iconsdir}/*.*
%{_liconsdir}/*.*
%{_miconsdir}/*.*

%files common
%{_mandir}/man5/*
%config(noreplace) %{_sysconfdir}/xpdfrc
%dir %{_sysconfdir}/%{name}
%lang(ar) %config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.arabic
%lang(zh_CN) %config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.chinese-simplified
%lang(zh_TW) %config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.chinese-traditional
%lang(el) %config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.greek
%lang(iw) %config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.hebrew
%lang(ja) %config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.japanese
%lang(ko) %config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.korean
%lang(th) %config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.thai
%lang(tr) %config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.turkish
# cyrillic and latin2 are not langs, many languages are cyrillic/latin2
%config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.cyrillic
%config(noreplace) %{_sysconfdir}/%{name}/add-to-xpdfrc.latin2
%dir %{_datadir}/%{name}
%lang(ar) %{_datadir}/%{name}/arabic
%lang(zh_CN) %{_datadir}/%{name}/chinese-simplified
%lang(zh_TW) %{_datadir}/%{name}/chinese-traditional
%lang(el) %{_datadir}/%{name}/greek
%lang(iw) %{_datadir}/%{name}/hebrew
%lang(ja) %{_datadir}/%{name}/japanese
%lang(ko) %{_datadir}/%{name}/korean
%lang(th) %{_datadir}/%{name}/thai
%lang(tr) %{_datadir}/%{name}/turkish
%{_datadir}/%{name}/cyrillic
%{_datadir}/%{name}/latin2


%changelog
* Thu Feb 09 2023 ghibo <ghibo> 4.04-2.mga9
+ Revision: 1939635
- Rebuild for aging

* Fri Apr 22 2022 ns80 <ns80> 4.04-1.mga9
+ Revision: 1852595
- new version 4.04

* Sun Apr 03 2022 umeabot <umeabot> 4.03-2.mga9
+ Revision: 1842325
- Mageia 9 Mass Rebuild

* Sun Feb 28 2021 neoclust <neoclust> 4.03-1.mga9
+ Revision: 1694527
- New version 4.03: Fixes CVE-2020-35376 and CVE-2020-25725 (mga#28474)

* Wed Aug 19 2020 joequant <joequant> 4.02-5.mga8
+ Revision: 1615760
- fix build

* Wed Jul 08 2020 ns80 <ns80> 4.02-4.mga8
+ Revision: 1602928
- add Fedora patch for CVE-2019-12360 (mga#26920)

* Tue Feb 18 2020 umeabot <umeabot> 4.02-3.mga8
+ Revision: 1541453
- Mageia 8 Mass Rebuild

* Fri Dec 27 2019 ns80 <ns80> 4.02-2.mga8
+ Revision: 1470704
- add patch for CVE-2019-17064(mga#25973)

* Thu Sep 26 2019 ns80 <ns80> 4.02-1.mga8
+ Revision: 1446300
- new version 4.02 (mga#25364)

* Thu Apr 04 2019 ns80 <ns80> 4.01.01-1.mga7
+ Revision: 1385802
- new version 4.01.01 for CVE-2018-717[3-5], CVE-2018-745[24], CVE-2018-16368 (mga#24504)

* Sun Sep 23 2018 umeabot <umeabot> 3.04-7.mga7
+ Revision: 1301958
- Mageia 7 Mass Rebuild

* Fri Jun 08 2018 wally <wally> 3.04-6.mga7
+ Revision: 1235482
- build with motif instead of lesstif

* Mon Feb 01 2016 umeabot <umeabot> 3.04-5.mga6
+ Revision: 930062
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 3.04-4.mga5
+ Revision: 747323
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 3.04-3.mga5
+ Revision: 690747
- Mageia 5 Mass Rebuild

* Thu Aug 21 2014 luigiwalser <luigiwalser> 3.04-2.mga5
+ Revision: 666220
- remove old MandrivaLinux category from desktop menu entry file

* Fri Jun 06 2014 luigiwalser <luigiwalser> 3.04-1.mga5
+ Revision: 633903
- 3.04
- remove conditional bundled freetype2 and lesstif
  (remove patch 9)
- update language packs
- rediff patches 2, 16, and 17
- remove no longer needed patch 18
- update patch 20 (from fedora)
- remove upstream patches 27 and 29
- do not build shared library, obsoleted by poppler
  (remove patches 0 and 28)
- fix perl substitutions in spec to change correct files

* Sat Oct 19 2013 umeabot <umeabot> 3.03-6.mga4
+ Revision: 532659
- Mageia 4 Mass Rebuild

* Thu Aug 22 2013 luigiwalser <luigiwalser> 3.03-5.mga4
+ Revision: 469194
- add patch from mancha to fix CVE-2012-2142 (rhbz#789936)

* Mon Jan 14 2013 umeabot <umeabot> 3.03-4.mga3
+ Revision: 387298
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Oct 26 2012 malo <malo> 3.03-3.mga3
+ Revision: 310407
- update RPM group

* Mon Feb 20 2012 fwang <fwang> 3.03-2.mga2
+ Revision: 211165
- correct link order
- fi xlink order
+ dmorgan <dmorgan>
- Do not package .la files

* Mon Feb 20 2012 luigiwalser <luigiwalser> 3.03-1.mga2
+ Revision: 211157
- fix BuildRequires
- fix another changed command in xpdfrc
- remove redundant command from spec
- do not force default paper size
- remove obsolete configure options
- versionate provides
- update chinese patch for changed xpdf command
- fix rediffed patch 0
- add patch 27 to fix compile error due to missing cast
- rediff patches and remove upstreamed ones
+ fwang <fwang>
- tighen br
+ tv <tv>
- new release
+ anaselli <anaselli>
- Fixes bug #2263 - missing file aconf.h

* Wed Jul 06 2011 dams <dams> 3.02pl6-1.mga2
+ Revision: 119433
- update to 3.02pl6
- disable t1lib

* Tue May 17 2011 dmorgan <dmorgan> 3.02-17.mga1
+ Revision: 99413
- imported package xpdf


* Tue May 11 2010 Oden Eriksson <oeriksson@mandriva.com> 3.02-17mdv2010.1
+ Revision: 544475
- provide shared libs

* Tue Oct 20 2009 Oden Eriksson <oeriksson@mandriva.com> 3.02-16mdv2010.0
+ Revision: 458393
- P25: security fixes for CVE-2009-3603,3604,3605,3606,3608,3609

* Mon Sep 21 2009 Thierry Vignaud <tv@mandriva.org> 3.02-15mdv2010.0
+ Revision: 446263
- rebuild

* Sun Apr 19 2009 Frederik Himpe <fhimpe@mandriva.org> 3.02-14mdv2009.1
+ Revision: 368008
- Switch patch23 to official 3.02pl2 patch, which fixes the same security
  problems
- Add rediffed 3.02pl3.patch to fix CVE-2009-0195

* Mon Apr 13 2009 Funda Wang <fwang@mandriva.org> 3.02-13mdv2009.1
+ Revision: 366741
- drop autoconf
- rediff crash patch
- rediff ppm patch

  + Michael Scherer <misc@mandriva.org>
    - fix patch3

  + Antoine Ginies <aginies@mandriva.com>
    - rebuild

* Thu Aug 07 2008 Thierry Vignaud <tv@mandriva.org> 3.02-12mdv2009.0
+ Revision: 266146
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas

* Fri Jun 06 2008 Funda Wang <fwang@mandriva.org> 3.02-11mdv2009.0
+ Revision: 216393
- updaet default chinese font name

* Wed Mar 19 2008 Frederic Crozat <fcrozat@mandriva.com> 3.02-10mdv2008.1
+ Revision: 188830
- Kill xpdf-tools, now provided by poppler package

  + Thierry Vignaud <tv@mandriva.org>
    - fix summary-not-capitalized
    - kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Sun Dec 16 2007 Funda Wang <fwang@mandriva.org> 3.02-9mdv2008.1
+ Revision: 120527
- fix CVE 2007 4352,5392,5393.

  + Thierry Vignaud <tv@mandriva.org>
    - buildrequires X11-devel instead of XFree86-devel

* Fri Sep 14 2007 Funda Wang <fwang@mandriva.org> 3.02-8mdv2008.0
+ Revision: 85615
- fix conflicts version

* Thu Sep 13 2007 Funda Wang <fwang@mandriva.org> 3.02-7mdv2008.0
+ Revision: 85219
- split out unicodemap and xpdfrc so that other packages such as kpdf could suggest it

* Wed Sep 12 2007 Funda Wang <fwang@mandriva.org> 3.02-6mdv2008.0
+ Revision: 84631
- fix bug#17626

* Tue Sep 11 2007 Paulo Andrade <pcpa@mandriva.com.br> 3.02-5mdv2008.0
+ Revision: 84434
- Add Requires to user interface required fonts.

  + Thierry Vignaud <tv@mandriva.org>
    - kill desktop-file-validate's 'warning: key "Encoding" in group "Desktop Entry" is deprecated'

* Sun Aug 12 2007 Pixel <pixel@mandriva.com> 3.02-4mdv2008.0
+ Revision: 62246
- fix .desktop so that firefox correctly calls xpdf (#28720)

* Wed Aug 01 2007 Funda Wang <fwang@mandriva.org> 3.02-3mdv2008.0
+ Revision: 57555
- Add patch to fix CVE-2007-3387

* Wed Jul 04 2007 Andreas Hasenack <andreas@mandriva.com> 3.02-2mdv2008.0
+ Revision: 48237
- autoconf-2.5x is no more
- rebuild with new rpm-mandriva-setup package (-fstack-protector)


* Sat Mar 10 2007 Giuseppe Ghibò <ghibo@mandriva.com> 3.02-1mdv2007.1
+ Revision: 140528
- Reworked Patch3 (mozilla)
- Reworked Patch17 (can-2005-0206).
- Removed Patch25 (pl2), merged upstream.
- Removed Patch26 (noftinternal), merged upstream.
- Removed Patch27 (cve-2007-0104), mainstream 3.02 code modified to include the same features.

* Sun Feb 18 2007 Giuseppe Ghibò <ghibo@mandriva.com> 3.01pl2-5mdv2007.1
+ Revision: 122239
- Added Patch27 from Stew Benedict, security fix for CVE-2007-0104
  (close bug #28263).

* Sat Jan 06 2007 Götz Waschk <waschk@mandriva.org> 3.01pl2-4mdv2007.1
+ Revision: 104770
- Import xpdf

* Sat Jan 06 2007 Götz Waschk <waschk@mandriva.org> 3.01pl2-4mdv2007.1
- unpack patches

* Wed Jun 21 2006 Frederic Crozat <fcrozat@mandriva.com> 3.01pl2-3mdv2007.0
- Add conflicts to ease upgrade
- Patch26 (David Turner): don't use freetype internals

* Fri Apr 21 2006 Götz Waschk <waschk@mandriva.org> 3.01pl2-2mdk
- split out the command line tools

* Sat Feb 11 2006 Giuseppe Ghibò <ghibo@mandriva.com> 3.01pl2-1mdk
- Removed Patch22,23,24 (merged into 3.01pl2 Patch25).

* Wed Feb 01 2006 Stew Benedict <sbenedict@mandriva.com> 3.01-1.2.20060mdk
- P24: security fix for CVE-2006-0301

* Tue Jan 03 2006 Stew Benedict <sbenedict@mandriva.com> 3.01-1.1.20060mdk
- security update for CVE-2005-3191,3192,3193 (P22)                                                         
- additional overflow issues discovered by Chris Evans (P23)                                                
  (CVE-2005-3624,3625,3626,3627)

* Thu Aug 25 2005 Giuseppe Ghibò <ghibo@mandriva.com> 3.01-1mdk
- Release 3.01.
- Rebuilt Patch2.
- Removed Patch7, Patch12, Patch13, Patch14, Patch19, Patch21 (merged upstream).
- Removed Patch15, Patch20, Patch22.
- Rebuilt Patch10.
- Added Patch19 (core), Patch20 (crash), Patch21 (xfont) merged from RH.

* Thu Aug 25 2005 Giuseppe Ghibò <ghibo@mandriva.com> 3.00pl3-9mdk
- Added Patches from Funda Wang (Patch21, Patch22) for bug #17308.

* Wed Aug 17 2005 Laurent MONTEL <lmontel@mandriva.com> 3.00pl3-8mdk
- Fix crash on x86_64
- Add patch20: fix compile on x86_64

* Thu Aug 04 2005 Giuseppe Ghibò <ghibo@mandriva.com> 3.00pl3-7mdk
- Added Patch18 for gcc 4.0.1.

* Sun Apr 03 2005 Giuseppe Ghibò <ghibo@mandrakesoft.com> 3.00pl3-6mdk
- Fix bug #14236.

* Wed Mar 16 2005 Giuseppe Ghibò <ghibo@mandrakesoft.com> 3.00pl3-5mdk
- Added Source14 (for fixing bug #12209).

* Thu Mar 10 2005 Giuseppe Ghibò <ghibo@mandrakesoft.com> 3.00pl3-4mdk
- Added Patch17 for CAN-2005-0206 (from Stew's updates).

* Wed Mar 09 2005 Giuseppe Ghibò <ghibo@mandrakesoft.com> 3.00pl3-3mdk
- Added entry for Chinese Traditional and Simplified (fix bug #14236).

* Mon Feb 14 2005 Giuseppe Ghibò <ghibo@mandrakesoft.com> 3.00pl3-2mdk
- Added Patch15 for MDKSA-2005:017 (CAN-2005-0064).

* Wed Jan 19 2005 Giuseppe Ghibò <ghibo@mandrakesoft.com> 3.00pl3-1mdk
- Added pl1,pl2,pl3 patches.

* Wed Jan 19 2005 Frederic Lepied <flepied@mandrakesoft.com> 3.00-9mdk
- use www-browser in urlCommand

* Tue Jan 11 2005 Olivier Thauvin <thauvin@aerov.jussieu.fr> 3.00-8mdk
- Rebuild for t1lib
- remove redondant requires

* Tue Jul 20 2004 Giuseppe Ghibò <ghibo@mandrakesoft.com> 3.00-7mdk
- Rebuilt.

* Fri Jun 04 2004 Laurent Montel <lmontel@mandrakesoft.com> 3.00-6mdk
- Rebuild against new gcc

